--speedlimittts ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MODEL.SETPERSISTENT.lua.wSLTTSVoice_sltts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wSLTTSVoiceSecondPhrase_sltts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wSLTTSVoiceSecondPhraseUnit_sltts = BOOL_MODEL(true)
MODEL.SETPERSISTENT.lua.wCorrectionSpeedUnit_sltts = BOOL_MODEL(false)
wspeed_units_sltts = {kph = "km/h", mph = "mph"}
wSpeedLimitSpeakingID_sltts = 0
wTestSpeakingID_sltts = 0
wSpeedLimit_sltts = 0
sc_wspeedmode_restart_sltts = function()
	if not MODEL.EXISTS.lua.wSLTTSVoice() then
		obs_wspeedmode_sltts:START()
	end
end
sc_wReadOutSpeedLimitSupported_sltts = function()
	return MODEL.regional.is_it_voice_localizable(m_i18n_voice("You can increase speed.")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Limit %s")) and MODEL.regional.current_voice.is_tts()
end
sc_wspeedmode_change_sltts = function()
	if MODEL.warning.driveralert.speed_limit() and wSpeedLimit_sltts and MODEL.warning.driveralert.speed_limit() > wSpeedLimit_sltts and MODEL.warning.driveralert.speed_limit() > MODEL.navigation.car.current_speed() and MODEL.lua.wSLTTSVoice_sltts() and sc_wReadOutSpeedLimitSupported_sltts() then
		sc_wspeedlimitsayspeech_sltts(sc_wGetSL_sayphase_sltts(MODEL.warning.driveralert.speed_limit()))
	end
	wSpeedLimit_sltts = MODEL.warning.driveralert.speed_limit()
end
sc_wGetSL_sayphase_sltts = function(limit)
	local limitphrasepart = (MODEL.lua.wCorrectionSpeedUnit_sltts() and sc_wCorrectionSpeedUnitSupported_sltts() or not MODEL.lua.wSLTTSVoiceSecondPhraseUnit_sltts()) and 2 or 0
	local limitphraseunit = MODEL.lua.wSLTTSVoiceSecondPhraseUnit_sltts() and MODEL.lua.wCorrectionSpeedUnit_sltts() and sc_wCorrectionSpeedUnitSupported_sltts() and sc_wtranslateunit_sltts(MODEL.other.format_speed(limit, MODEL.regional.units(), 1, 1), wspeed_units_sltts) or L""
	local limitphrase = MODEL.lua.wSLTTSVoiceSecondPhrase_sltts() and translated_voice_format(m_i18n_voice("Limit %s"), MODEL.other.format_speed(limit, MODEL.regional.units(), 1, limitphrasepart) .. limitphraseunit) or L""
	return translate_voice("You can increase speed.") .. L" " .. limitphrase
end
sc_wspeedlimitsayspeech_sltts = function(text)
	local wsaying = wDASpeakingID_datts
	if wSpeedLimitSpeakingID_sltts then
		wsaying = false
		PromptCancel(wSpeedLimitSpeakingID_sltts)
		wSpeedLimitSpeakingID_sltts = 0
	end
	if not wsaying and not (MODEL.sound.os_muted() or MODEL.sound.voice_muted()) then
		wSpeedLimitSpeakingID_sltts = MODEL.sound.speech.say("voice.ui", text, {priority = 19, boosted_priority = 20, callback = function(res) if res > 1 then wSpeedLimitSpeakingID_sltts = 0 end end})
	end
end
sc_wSLTTS_OnRelease_sltts = function()
	sc_NextStateAnim(st_wSLSoundTTS_sltts, "horz_scroll", 1, "")
end
createState("st_wSLSoundTTS_sltts")
st_wSLSoundTTS_sltts:useLayers(backgroundLayers, ui_wSLSoundTTS_sltts)
st_wSLSoundTTS_sltts.init = function()
	txtTitle.TEXT = m_i18n("Speed Limit TTS Pro Test")
end
st_wSLSoundTTS_sltts.done = function()
	if wTestSpeakingID_sltts then
		PromptCancel(wTestSpeakingID_sltts)
		wTestSpeakingID_sltts = 0
	end
end
sc_wSecondPhraseTTSSL_play_sltts = function()
	if wTestSpeakingID_sltts then
		PromptCancel(wTestSpeakingID_sltts)
		wTestSpeakingID_sltts = 0
	end
	wTestSpeakingID_sltts = MODEL.sound.speech.say("voice.ui", sc_wGetSL_sayphase_sltts(90), {callback = function(res) if res > 1 then wTestSpeakingID_sltts = 0 end end})
end
sc_wSetCorrectionSpeedUnit_sltts = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, translate(m_i18n("You need using this function only if selected TTS voice misspells speed units with some TTSPro features.")))
	MODEL.screen.msgbox.new.set_line_wstr(2, translate(m_i18n("Turn it on anyway?")))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wSetCorrectionSpeedUnitOK_sltts", m_i18n("Turn On"), "", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
sc_wSetCorrectionSpeedUnitOK_sltts = function()
	MODEL.lua.wCorrectionSpeedUnit_sltts = true
end
sc_wCorrectionSpeedUnitSupported_sltts = function()
	return MODEL.regional.is_it_voice_localizable(m_i18n_voice(wspeed_units_sltts.kph)) and MODEL.regional.is_it_voice_localizable(m_i18n_voice(wspeed_units_sltts.mph)) and MODEL.regional.current_voice.is_tts()
end
sc_wtranslateunit_sltts = function(wstr,type)
	local res = L""
	for i,v in pairs(type) do
		if translate(v) == wstr then
			res = L" " .. translate_voice(v)
			break
		end
	end
	return res
end
sc_wspeedmode_restart_sltts()


--datts ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MODEL.SETPERSISTENT.lua.wdattsvoice_datts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTTSProGuidancePriority_datts = BOOL_MODEL(true)
wDASpeakingID_datts = 0
wTestSpeakingID_datts = 0
wLockSpeakingID_datts = -1
sc_wDADing_restart = function()
	if not MODEL.EXISTS.lua.wReadOutDASupported() then
		obs_DriverAlertWarn:STOP()
		obs_DriverAlertWarn_datts:START("NO_TRIGGER")
	end
end
sc_DADing_datts = function()
	if st_EasyNav.isActive and vDAIsVisible() and MODEL.lua.DAEnabled() and not MODEL.lua.dragMode() and not MODEL.lua.vVehicleIsPedestrian() and (not MODEL.navigation.curr_speedcam.category.valid() or MODEL.warning["speedcam_visualtype_" .. MODEL.navigation.curr_speedcam.category()]() == 0) and not MODEL.lua.showDiriconBg() then
		if sc_wReadOutDASupported_sign_datts() and MODEL.lua.wdattsvoice_datts() then
			sc_wDAsayspeech_datts(sc_wGetDADing_sayphase_datts())
		else
			PLAYSOUND("alarmeffect", "!ding")
		end
	end
end
sc_wReadOutDASupported_datts = function()
	local res = MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Soon")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("and"))
	if not res then
		return res
	end
	for i = 0, MODEL.ui.list_wDATypes_datts.unfiltered_list.size() - 1 do
		if not MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[i].text()) then
			res = false
			break
		end
	end
	return res
end
sc_wReadOutDASupported_sign_datts = function()
	local da = MODEL.warning.driveralert
	return MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Soon")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("and")) and (da.alerts.size() > 1 and MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[0].type()].text()) and MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[1].type()].text()) or MODEL.regional.is_it_voice_localizable(MODEL.ui.list_wDATypes_datts.unfiltered_list[da.alerts[0].type()].text()))
end
sc_wTTSProPriorityVisible_datts = function()
	return MODEL.lua.wdattsvoice_datts() and sc_wReadOutDASupported_datts() and MODEL.lua.DAEnabled() and not MODEL.EXISTS.lua.wReadOutDASupported()
end
sc_wDAsayspeech_datts = function(text)
	if MODEL.sound.os_muted() or MODEL.sound.voice_muted() then
		return
	end
	if not MODEL.lua.wTTSProGuidancePriority_datts() then
		MODEL.sound.speech.unlock(wLockSpeakingID_datts)
	end
	if wDASpeakingID_datts then
		PromptCancel(wDASpeakingID_datts)
		wDASpeakingID_datts = 0
	end
	if wSpeedLimitSpeakingID_sltts then
		PromptCancel(wSpeedLimitSpeakingID_sltts)
		wSpeedLimitSpeakingID_sltts = 0
	end
	if wReserveSpeakingID_datts then
		PromptCancel(wReserveSpeakingID_datts)
		wReserveSpeakingID_datts = 0
	end
	if MODEL.lua.wTTSProGuidancePriority_datts() then
		if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
			wDASpeakingID_datts = MODEL.sound.speech.say("voice.ui", text, {priority=20, boosted_priority=25, callback = function(res) if res > 1 then wDASpeakingID_datts = 0 end end})
		end
	else
		wLockSpeakingID_datts = MODEL.sound.speech.lock()
		wDASpeakingID_datts = MODEL.sound.speech.say("voice.ui", text, {lock_id = wLockSpeakingID_datts, unlock_after_done = true, priority = 100, boosted_priority = 100, callback = function(res) if res > 1 then wDASpeakingID_datts = 0 end end})
	end
end
sc_wGetDADing_sayphase_datts = function()
	local da = MODEL.warning.driveralert
	if da.settings.warn_method() == 1 then
		return da.alerts.size() > 1 and sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(), da.alerts[0].is_active()) .. L" " .. sc_wGetDADing_sayphase_sign_datts(da.alerts[1].type(), da.alerts[1].is_active(), da.alerts[0].is_active()) or sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(), da.alerts[0].is_active())
	else
		local iconmodel = da.alerts.size() > 1 and da.alerts[1].is_active() and 1 or 0
		return da.alerts.size() > 1 and da.alerts[0].is_active() and da.alerts[1].is_active() and sc_wGetDADing_sayphase_sign_datts(da.alerts[0].type(),true) .. L", " .. sc_wGetDADing_sayphase_sign_datts(da.alerts[1].type(),true) or sc_wGetDADing_sayphase_sign_datts(da.alerts[iconmodel].type(),true)
	end
end
sc_wGetDADing_sayphase_sign_datts = function(signindex,signactive,signprevactive)
	local phrase = signindex < MODEL.ui.list_wDATypes_datts.unfiltered_list.size() and MODEL.ui.list_wDATypes_datts.unfiltered_list[signindex].text() or ""
	return translate_voice(not signactive and (signprevactive ~= nil and not signprevactive and "and" or "Soon") or "") .. (not signactive and L" " or L"") .. translate_voice(phrase)
end
wDATypesTemp_builded_datts = false
sc_wWarningSignSoundTTS_OnRelease_datts = function()
	if not wDATypesTemp_builded_datts then
		sc_wDATypesTemp_build_datts()
	end
	sc_NextStateAnim(st_wWarningSignSoundTTS_datts, "horz_scroll", 1, "")
end
sc_wDATypesTemp_build_datts = function()
	MODEL.screen.filter_unique_by_index(DAiconIdx + 1)
	MODEL.screen.set_current_icongroup("sys")
	local iconbmp = nil
	local res = (DAiconIdx == 4 and "high/" or (DAiconIdx == 2 and "mid/" or "low/"))
	res = "images/da/" .. res
	local iconbmp_saved = "___"
	for i = 0, MODEL.screen.icons.size() - 1 do
		iconbmp = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), DAiconIdx + 1)
		if string.find(iconbmp, res) ~= nil then
			ui.list_wDATypesTemp_datts:add({bmp=string.gsub(iconbmp, res, "")})
		end
	end
	ui.list_wDATypesTemp_datts:sort("bmp")
	for i = 0, MODEL.ui.list_wDATypesTemp_datts.size() - 1 do
		iconbmp = MODEL.ui.list_wDATypesTemp_datts[i].bmp()
		if string.find(iconbmp, iconbmp_saved) == nil and iconbmp ~= "na.bmp" then
			iconbmp_saved = string.sub(iconbmp, 1, 3)
			local currentDA = MODEL.ui.list_wDATypes_datts.unfiltered_list[tonumber(iconbmp_saved)]
			if currentDA.bmp() == "na.bmp" then
				currentDA.bmp = iconbmp
			end
		end
	end
	MODEL.ui.list_wDATypesTemp_datts.clear()
	wDATypesTemp_builded_datts = true
end
createState("st_wWarningSignSoundTTS_datts")
st_wWarningSignSoundTTS_datts:useLayers(backgroundLayers, ui_wWarningSignSoundTTS_datts)
st_wWarningSignSoundTTS_datts.init = function()
	txtTitle.TEXT = m_i18n("Warning Sign TTS Pro Test")
end
----------------ari st
createState("st_DASoundTTSSettings")
st_DASoundTTSSettings:useLayers(backgroundLayers, ui_DASoundTTSSettings)
st_DASoundTTSSettings.init = function()
	txtTitle.TEXT = m_i18n("Driver Alert Settings")
end

sc_DASoundTTSSettings_OnRelease = function()
	sc_NextStateAnim(st_DASoundTTSSettings, "horz_scroll", 1, "")
end

---------------ari st
st_wWarningSignSoundTTS_datts.done = function()
	if wTestSpeakingID_datts then
		PromptCancel(wTestSpeakingID_datts)
		wTestSpeakingID_datts = 0
	end
end
sc_wGetPhaseBmpDA_sayTest_datts = function()
	return "images/da/" .. (DAiconIdx == 4 and "high/" or (DAiconIdx == 2 and "mid/" or "low/")) .. MODEL["*"].bmp()
end
sc_wDATTSVoice_play_datts = function()
	if wTestSpeakingID_datts then
		PromptCancel(wTestSpeakingID_datts)
		wTestSpeakingID_datts = 0
	end
	if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
		wTestSpeakingID_datts = MODEL.sound.speech.say("voice.ui", translate_voice(MODEL["*"].text()), {callback = function(res) if res > 1 then wTestSpeakingID_datts = 0 end end})
	end
end
sc_wDADing_restart()



--timeeta_tts +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MODEL.SETPERSISTENT.lua.wETATTSVoice_etatts = BOOL_MODEL(false)
sc_wReadOutRouteSummaryTimeSupported_etatts = function()
	return MODEL.regional.is_it_voice_localizable(m_i18n_voice("Arrival to destination at %s.")) and MODEL.regional.current_voice.is_tts()
end
sc_wReadOutRouteSummaryTime_etatts = function()
	if MODEL.lua.wETATTSVoice_etatts() and sc_wReadOutRouteSummaryTimeSupported_etatts() and MODEL.navigation.eta_at_destination.valid() then
		return translated_voice_format(m_i18n_voice("Arrival to destination at %s."), MODEL.other.format_time_dayperiod(MODEL.navigation.eta_at_destination(), MODEL.regional.timeformat(), 0))
	else
		return L""
	end
end
sc_wReadOutTime_etatts = function()
	if sc_wReadOutRouteSummaryTime_etatts() ~= L"" then
		MODEL.sound.speech.say("voice.ui", sc_wReadOutRouteSummaryTime_etatts())
	end
end
sc_ReadOutRouteSummary = function(summary)
	PromptCancel(gRouteSummaryID)
	gRouteSummaryID = 0
	MODEL.lua.RouteSummaryText = summary or MODEL.sound.voice.get_route_summary()
	if MODEL.lua.RouteSummaryText() ~= L"" then
		MODEL.lua.RouteSummaryIsSpeaking = true
		gRouteSummaryID = MODEL.sound.speech.say("voice.info", MODEL.lua.RouteSummaryText() .. L" , " .. sc_wReadOutRouteSummaryTime_etatts(), {callback = sc_ReadOutRouteSummary_Callback})
		MODEL.lua.ReadOutRouteSummaryHappened = true
	end
end


--toll_booth_warning +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MODEL.SETPERSISTENT.lua.wTollBoothWarning = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTollBoothDistanceWarning = INT_MODEL(700)
MODEL.SETPERSISTENT.lua.wTollBoothTTSVoice = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTollBoothTTSVoiceDistancePhrase = BOOL_MODEL(true)
MODEL.SET.lua.wTollBoothTrigger = BOOL_MODEL(true)
MODEL.SET.lua.wTollBoothIndex = INT_MODEL(0)
wTollBoothPopupID = -1
wTollBoothDelayedID = -1
wTollBoothOnDelayedID = -1
wTollBoothSpeakingID = 0
wTollBoothTestSpeakingID = 0
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}
sc_ConvertInputDistToCurrent_tollbooth = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end
sc_inpValueInteger_onchange_tollbooth = function()
	local acceptable, InputKeys = getNextInput_Int(ui.inpValueInteger_tollbooth.VALUE(), sc_ConvertInputDistToCurrent_tollbooth(50), sc_ConvertInputDistToCurrent_tollbooth(5000))
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.fuelinputkeys = InputKeys
	MODEL.regional.keyboard.smartkey_model("lua.fuelinputkeys")
end
sc_SelectValueInteger_tollbooth = function()
	sc_NextStateAnim(st_InputValueInteger_tollbooth, "horz_scroll", 1, "")
	txtTitle.TEXT = m_i18n("Set distance for warning")
	inpValueInteger_tollbooth.value = L""
	inpValueInteger_tollbooth.EMPTYTITLE = translated_format(m_i18n("<Enter Number (%s)>"), (towstring(sc_ConvertInputDistToCurrent_tollbooth(50)) .. L".." .. towstring(sc_ConvertInputDistToCurrent_tollbooth(5000))))
	sc_inpValueInteger_onchange_tollbooth()
	KEY("RETURN", sc_SelectValueIntegerDone_tollbooth)
	ui.vKeyTableDone = sc_SelectValueIntegerDone_tollbooth
end
createState("st_InputValueInteger_tollbooth")
st_InputValueInteger_tollbooth:useLayers(backgroundLayers, ui_InputValueInteger_tollbooth)
st_InputValueInteger_tollbooth.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
	MODEL.lua.InputValidatorIsDate = true
	wTmpdateDelimiter = MODEL.lua.dateDelimiter()
	MODEL.lua.dateDelimiter = 0
end
st_InputValueInteger_tollbooth.done = function()
	KEY("RETURN")
	MODEL.lua.InputValidatorIsDate = false
	MODEL.lua.dateDelimiter = wTmpdateDelimiter
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
sc_SelectValueIntegerDone_tollbooth = function()
	local result = var.new()
	inpValueInteger_tollbooth:ISEMPTY(result)
	if not result() then
		MODEL.lua.wTollBoothDistanceWarning = float.toInt(float.new(tostring(ui.inpValueInteger_tollbooth.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
sc_wReadOutTollBoothSupported = function()
	return MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Toll booth,")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("After %s"))
end
sc_wGetTextReadOutTollBooth = function(dist)
	local distphrase = dist > 20 and MODEL.lua.wTollBoothTTSVoiceDistancePhrase() and (translated_voice_format(m_i18n_voice("After %s"), builtin.format(L"%{distance:3}", dist)) .. L": ") or L""
	return distphrase .. translate_voice("Toll booth,")
end
sc_wReadOutTollBooth = function()
	if not MODEL.navigation.is_in_simulation() and MODEL.lua.wTollBoothTTSVoice() then
		if sc_wReadOutTollBoothSupported() and not (wDASpeakingID or wSpeedCameraSpeakingID or wDASpeakingID_datts or MODEL.sound.os_muted() or MODEL.sound.voice_muted()) then
			local text = sc_wGetTextReadOutTollBooth(MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].remaining_length())
			if wTollBoothSpeakingID then
				PromptCancel(wTollBoothSpeakingID)
				wTollBoothSpeakingID = 0
			end
			if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
				wTollBoothSpeakingID = MODEL.sound.speech.say("voice.ui", text, {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wTollBoothSpeakingID = 0 end end})
			end
		else
			MODEL.sound.playchanneltest("alarmeffect", L"!msgbox")
		end
	end
end
sc_wTollBoothSetIndex = function()
	local witiner = MODEL.route.list.navigated.itiner.list
	local tollindex = 0
	for i = 0, witiner.size() - 1 do
		if witiner[i].remaining_length() > (MODEL.lua.wTollBoothDistanceWarning() + witiner[0].remaining_length()) then
			break
		end
		if witiner[i].type_small() == 40 then
			tollindex = i
			break
		end
	end
	MODEL.lua.wTollBoothIndex = tollindex
end
sc_wTollBoothStatusChanged = function()
	killDelayed(wTollBoothDelayedID)
	wTollBoothDelayedID = doDelayed(5, sc_wCheckTollBoothStatus)
end
sc_wCheckTollBoothStatus = function()
	if MODEL.route.list.navigated.has_navigable_path() and MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].type_small() == 40 and MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].remaining_length() <= MODEL.lua.wTollBoothDistanceWarning() and MODEL.gps.connection_status() < 3 and (MODEL.navigation.car_pos_valid() or MODEL.gps.valid() or MODEL.navigation.dead_reckoning()) then
		sc_wShowTollBoothPopup()
	else
		sc_wRemoveTollBoothPopup()
	end
end
sc_wShowTollBoothPopup = function()
	sc_RemoveMapPopupById(wTollBoothPopupID)
	local targetlayer = wPortrait and ui_wMapSidePanel_ptls_TollBooth or ui_wMapSidePanel_TollBooth
	MODEL.screen.msgbox.new.setup(1)
	MODEL.screen.msgbox.new.set_layer(targetlayer)
	MODEL.screen.msgbox.new.add_tag("popup")
	MODEL.screen.msgbox.new.set_title("tollbooth")
	wTollBoothPopupID = MODEL.screen.msgbox.create_new()
	if (st_EasyNav.isActive or vActiveState() == "st_screensaver") and MODEL.screen.msgbox.is_onscreen() and MODEL.screen.msgbox.on_screen.title() == "tollbooth" then
		sc_wReadOutTollBooth()
	end
end
sc_wRemoveTollBoothPopup = function()
	if wTollBoothSpeakingID then
		PromptCancel(wTollBoothSpeakingID)
		wTollBoothSpeakingID = 0
	end
	sc_RemoveMapPopupById(wTollBoothPopupID)
end
st_EasyNav:useLayers(ui_wTollBoothPropLayer,ui_wTollBoothPropLayer_uid)
sc_wTollBoothUpdateOn = function()
	killDelayed(wTollBoothOnDelayedID)
	wTollBoothOnDelayedID = doDelayed(1, function()
		MODEL.route.list.navigated.itiner.enable_update_list = true
		if not (MODEL.route.list.navigated.itiner.detailmode() == "normal" or MODEL.route.list.navigated.itiner.detailmode() == "verbose") then
			MODEL.route.list.navigated.itiner.detailmode = "normal"
		end
	end)
end
sc_wTollBoothTrigger = function()
	MODEL.lua.wTollBoothTrigger = false
	MODEL.lua.wTollBoothTrigger = true
end
sc_wTollBoothSettings_OnRelease_20 = function()
	sc_NextStateAnim(st_wTollBoothSettings, "horz_scroll", 1, "")
end
createState("st_wTollBoothSettings")
st_wTollBoothSettings:useLayers(backgroundLayers, ui_wTollBoothSettings)
st_wTollBoothSettings.init = function()
	obs_wtollboothwarning:STOP()
	obs_wtollboothwarning_itiner:STOP()
	txtTitle.TEXT = m_i18n("Toll Booth Warning Settings")
end
st_wTollBoothSettings.done = function()
	if wTollBoothTestSpeakingID then
		PromptCancel(wTollBoothTestSpeakingID)
		wTollBoothTestSpeakingID = 0
	end
end
st_wTollBoothSettings.exit = function()
	if MODEL.lua.wTollBoothWarning() then
		obs_wtollboothwarning:START()
		obs_wtollboothwarning_itiner:START()
	else
		sc_wRemoveTollBoothPopup()
	end
end
sc_wTollBoothTTS_play = function()
	if wTollBoothTestSpeakingID then
		PromptCancel(wTollBoothTestSpeakingID)
		wTollBoothTestSpeakingID = 0
	end
	if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
		wTollBoothTestSpeakingID = MODEL.sound.speech.say("voice.ui", sc_wGetTextReadOutTollBooth(MODEL.lua.wTollBoothDistanceWarning()), {callback = function(res) if res > 1 then wTollBoothTestSpeakingID = 0 end end})
	end
end
if MODEL.lua.wTollBoothWarning() then
	obs_wtollboothwarning:START("NO_TRIGGER")
	obs_wtollboothwarning_itiner:START()
end

--quickdetourtts +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

MODEL.SETPERSISTENT.lua.wQuickDetourTTSVoice_qdtts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wQuickDetourTTSVoiceFirstPhrase_qdtts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wQuickDetourTTSVoiceSparePhrase_qdtts = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wQuickDetourTTSVoiceStreetPhrase_qdtts = BOOL_MODEL(false)
wReserveSpeakingID_datts = 0
wTestSpeakingID_qdtts = 0
wQuickDetourDelayedID = -1
sc_wReadOutQuickDetourSupported_qdtts = function()
	return MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("After %s")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Possible alternative route")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("more shortly on %s")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("more long on %s"))
end
sc_wGetTextReadOutQuickDetour_qdtts = function(distvalid,dist,calculated,sparedist,streetname)
	local distphrase = distvalid and dist > 10 and MODEL.lua.wQuickDetourTTSVoiceFirstPhrase_qdtts() and (translated_voice_format(m_i18n_voice("After %s"), builtin.format(L"%{distance:3}",dist)) .. L" ") or L""
	local sparephrase = calculated and MODEL.lua.wQuickDetourTTSVoiceSparePhrase_qdtts() and sc_wFormatSpareDistanceTTS_qdtts(sparedist) or L""
	local streetphrase = calculated and MODEL.lua.wQuickDetourTTSVoiceStreetPhrase_qdtts() and sc_TransformStreetNameforTurn_qdtts(streetname) or L""
	return distphrase .. translate_voice("Possible alternative route") .. streetphrase .. sparephrase
end
sc_wFormatSpareDistanceTTS_qdtts = function(sparedistance)
	if sparedistance == 0 then
		return L""
	end
	local absdistance = sparedistance
	if sparedistance < 0 then
		absdistance = -sparedistance
	end
	local prefix = (sparedistance < 0 and "more shortly on %s") or (sparedistance > 0 and "more long on %s" or "")
	return (L" , " .. translated_voice_format(m_i18n_voice(prefix), builtin.format(L"%{distance:3}",absdistance)))
	--return (L" , " .. translated_voice_format(m_i18n_voice(prefix), builtin.format(L"%{distance:3}",dist)))
end
sc_TransformStreetNameforTurn_qdtts = function(street)
	if street == L"" then
		return L""
	end
	local tempstreet = MODEL.sound.voice.format_street_name(L"for_turns" .. street)
	if wstring.find(tempstreet, L"for_turns", 1, true) == nil then
		return L" " .. tempstreet
	else
		return L" " .. sc_TransformStreetName(street)
	end
end
sc_wQuickDetourTTS_play_qdtts = function()
	local streetname = L""
	if MODEL.navigation.car_pos_valid() then
		streetname = MODEL.navigation.car.current_street()
	end
	if wTestSpeakingID_qdtts then
		PromptCancel(wTestSpeakingID_qdtts)
		wTestSpeakingID_qdtts = 0
	end
	wTestSpeakingID_qdtts = MODEL.sound.speech.say("voice.ui", sc_wGetTextReadOutQuickDetour_qdtts(true,200,true,-100,streetname), {callback = function(res) if res > 1 then wTestSpeakingID_qdtts = 0 end end})
end
sc_wQuickDetourTTS_OnRelease_qdtts = function()
	sc_NextStateAnim(st_wQuickDetourTTS_qdtts, "horz_scroll", 1, "")
end
createState("st_wQuickDetourTTS_qdtts")
st_wQuickDetourTTS_qdtts:useLayers(backgroundLayers, ui_wQuickDetourTTS_qdtts)
st_wQuickDetourTTS_qdtts.init = function()
	txtTitle.TEXT = m_i18n("Quick Detour TTS Pro Settings")
end
st_wQuickDetourTTS_qdtts.done = function()
	if wTestSpeakingID_qdtts then
		PromptCancel(wTestSpeakingID_qdtts)
		wTestSpeakingID_qdtts = 0
	end
end
st_EasyNav:useLayers(ui_wQuickDetourPropLayer)
sc_wQuickDetourStatusChanged = function()
	killDelayed(wQuickDetourDelayedID)
	wQuickDetourDelayedID = doDelayed(6, sc_wCheckQuickDetourStatus)
end
sc_wCheckQuickDetourStatus = function()
	if (not MODEL.navigation.curr_speedcam.category.valid() or MODEL.warning["speedcam_visualtype_" .. MODEL.navigation.curr_speedcam.category()]() == 0) and MODEL.screen.msgbox.is_onscreen() and MODEL.screen.msgbox.on_screen.title() == "quickdetour" and sc_wReadOutQuickDetourSupported_qdtts() and not (wDASpeakingID_datts or MODEL.sound.os_muted() or MODEL.sound.voice_muted()) then
		local text = sc_wGetTextReadOutQuickDetour_qdtts(MODEL.navigation.quickdetour_distance_on_route.valid(), MODEL.navigation.quickdetour_distance_on_route(), MODEL.navigation.quickdetour_calculated(), MODEL.navigation.quickdetour_dist(), MODEL.navigation.quickdetour_streetname())
		if wReserveSpeakingID_datts then
			PromptCancel(wReserveSpeakingID_datts)
			wReserveSpeakingID_datts = 0
		end
		if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
			wReserveSpeakingID_datts = MODEL.sound.speech.say("voice.ui", text, {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wReserveSpeakingID_datts = 0 end end})
		end
	else
		if wReserveSpeakingID_datts then
			PromptCancel(wReserveSpeakingID_datts)
			wReserveSpeakingID_datts = 0
		end
	end
end
-----------------------------------------------------------------------  restart ---------------------------------------------------------------------------------
st_SettingColor:useLayers(backgroundLayers, "ui_SettingColorRestart")
sc_akRestart_OnRelease = function()
    MODEL.screen.msgbox.new.setup(2)
    MODEL.screen.msgbox.new.set_line(1, m_i18n("The program will restart."))
    MODEL.screen.msgbox.new.setup_button(1, "sc_akRestart_OnReleaseDone", m_i18n("Restart"), "", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
    MODEL.screen.msgbox.create_new()
end
sc_akRestart_OnReleaseDone = function()
    SAVESETTINGS()
    NEXTSTATE(RestartState)
    doDelayed(25, APP_RESTART)
end
-------------------------------------------------------------------  capture_screen  ----------------------------------------------------------------------
wShowCaptureMessageTimer = -1
sc_wOverCapture = function()
	if type(sc_wCaptureScreen) == "function" then
		sc_wCaptureScreen()
	else
		if wShowCaptureMessageTimer ~= -1 then
			killDelayed(wShowCaptureMessageTimer)
			wShowCaptureMessageTimer = -1
			ui_wOverCaptureMessage:HIDE()
		end
		MODEL.ui.__screenshot()
		doDelayed(15, function()
			txt_wOverCaptureMessage.TEXT = m_i18n("DEBUG~Screen Captured")
			ui_wOverCaptureMessage:SHOW()
			wShowCaptureMessageTimer = doDelayed(100, function() ui_wOverCaptureMessage:HIDE() end)
		end)
	end
end
obs_wovercapture = var.observer({ONCHANGE = function() doDelayed(1, function() ui_wOverCapture:SHOW() ui_wOverCaptureMessage:HIDE() end) end, MODEL = MODEL.ui.vActiveState, TRIGGER_ON_START = false})
obs_wovercapture:START()
-------------------------------------------------------------------------  tunnel_tts ----------------------------------------------------------------------------------
MODEL.SETPERSISTENT.lua.wTunnelTTS_tuntts = BOOL_MODEL(false)
wTunnelSpeakingID_tuntts = 0
wTestSpeakingID_tuntts = 0
st_EasyNav:useLayers(ui_PropLayer_tuntts)
sc_wVoiceFormat_search_distance_tuntts = function(inputdistance)
	local unit_names = {"yards","meters","feet"}
	local voicetable_name = type(VOICE.distances["ttspro_"..unit_names[MODEL.regional.units() + 1]]) == "table" and "ttspro_" or ""
	local dist_table = VOICE.distances[voicetable_name..unit_names[MODEL.regional.units() + 1]]
	local _,_,outputdistance = VOICE.distance_formatter(inputdistance)
	if #dist_table == 0 or inputdistance > dist_table[#dist_table-1] then
		return builtin.format(L"%{distance:3}",outputdistance)
	end
	local ind = sc_wVoiceFormat_search_index_tuntts(outputdistance,dist_table)
	if outputdistance ~= dist_table[ind] then
		ind = sc_wVoiceFormat_search_index_tuntts(inputdistance,dist_table)
	end
	return VOICE.decode_string(dist_table[ind + 1], 1)
end
sc_wVoiceFormat_search_index_tuntts = function(distance, dist_table)
	if distance <= dist_table[1] then
		return 1
	elseif distance >= dist_table[#dist_table-1] then
		return #dist_table-1
	else
		local lo = 1
		local hi = #dist_table >> 1
		local dist, idx
		repeat
			idx = (lo+hi)>>1
			dist = dist_table[idx<<1 - 1]
			if  dist < distance then
				lo = idx
			elseif dist > distance then
				hi = idx
			else
				break
			end
		until (hi-lo < 2)
		if (dist < distance) then idx = idx+1 end
		return idx<<1 - 1
	end
end
sc_wReadOutTunnelSupported_tuntts = function()
	return MODEL.regional.is_it_voice_localizable(m_i18n_voice("Tunnel length %s")) and MODEL.regional.current_voice.is_tts() and not MODEL.EXISTS.lua.wTunnelTTS()
end
sc_wReadOutTunnel_test_tuntts = function()
	if wTestSpeakingID_tuntts then
		PromptCancel(wTestSpeakingID_tuntts)
		wTestSpeakingID_tuntts = 0
	end
	wTestSpeakingID_tuntts = MODEL.sound.speech.say("voice.ui", translated_voice_format(m_i18n_voice("Tunnel length %s"), sc_wVoiceFormat_search_distance_tuntts(1500)), {callback = function(res) if res > 1 then wTestSpeakingID_tuntts = 0 end end})
end
sc_wReadOutTunnel_tuntts = function()
	if MODEL.lua.wTunnelTTS_tuntts() and sc_wReadOutTunnelSupported_tuntts() and MODEL.navigation.remaining_tunnel_length.valid() and MODEL.navigation.remaining_tunnel_length() > 50 then
		if wTunnelSpeakingID_tuntts then
			PromptCancel(wTunnelSpeakingID_tuntts)
			wTunnelSpeakingID_tuntts = 0
		end
		if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
			wTunnelSpeakingID_tuntts = MODEL.sound.speech.say("voice.ui", translated_voice_format(m_i18n_voice("Tunnel length %s"), sc_wVoiceFormat_search_distance_tuntts(MODEL.navigation.remaining_tunnel_length())), {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wTunnelSpeakingID_tuntts = 0 end end})
		end
	end
end
-------------------------------------------------------------------------------  voice_tts_settings  ---------------------------------------------------------------------------
MODEL.SETPERSISTENT.lua.tts.numbers_mode = BOOL_MODEL(true)
MODEL.SETPERSISTENT.lua.tts.roadnumber_mode = BOOL_MODEL(true)
MODEL.SETPERSISTENT.lua.tts.sentence_variations = BOOL_MODEL(true)
MODEL.SETPERSISTENT.lua.tts.traffic_events_description = BOOL_MODEL(true)
MODEL.SETPERSISTENT.lua.tts.traffic_events_distance = BOOL_MODEL(false)
sc_wTTSExtraSettingsVisible = function()
	return type(VOICE.set_tts_settings) == "function"
end
sc_btn_TTSExtraSettingsOnRelease = function()
	sc_NextStateAnim(st_wTTSExtraSettings_tts, "horz_scroll", 1, "")
end
createState("st_wTTSExtraSettings_tts")
st_wTTSExtraSettings_tts:useLayers(backgroundLayers, "ui_List_Background", "ui_wTTSExtraSettings_tts")
st_wTTSExtraSettings_tts.init = function()
	txtTitle.TEXT = m_i18n("Extra TTS Settings")
end
st_wTTSExtraSettings_tts.done = function()
	VOICE["set_tts_settings"]()
end
sc_wTTSExtraSettings_getnumersmode = function(mode)
	return mode and (L"2 " .. translate(m_i18n("and")) .. L" 2 " .. translate(m_i18n("km"))) or (L"2 " .. translate(m_i18n("km")) .. L" " .. translated_format(m_i18n("DISTWUNIT~%dm"),200))
end
--------------------------------------------  arimi --------------------------------------------------------
------------------------------------- arimi @ Neoss75 ----------------------------------------------
